### mergetb portal dns configuration                                        ###
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#  This file contains the dns setup for the mergetb portal. Both forward and
#  reverse zones are defined.
#
#  Both zones start out empty. All records are provided through ddns. Each zone 
#  has requires a key for updates. A member of a zone may set its own name if 
#  it has the #  appropriate zone key. This allows for expansion of the 
#  respective zones without having to statically update the DNS setup.

options
{
  directory               "/var/named";
  dump-file               "data/cache_dump.db";
  statistics-file         "data/named_stats.txt";
  memstatistics-file      "data/named_mem_stats.txt";

  listen-on port 53 {
    127.0.0.1;
    {{ proxy[proxy_index].external.ip.addr }};
    {{ proxy[proxy_index].internal.ip.addr }};
  };

  allow-query       { any; };
  allow-query-cache { any; };

  {% if proxy_index == 0 %}
  allow-transfer    { localhost; {{ proxy.1.internal.ip.addr }}; };
  {% else %}
  allow-transfer    { none; };
  {% endif %}

  recursion yes;

  dnssec-enable yes;
  dnssec-validation yes;

  pid-file "/run/named/named.pid";
  session-keyfile "/run/named/session.key";

  managed-keys-directory "/var/named/dynamic";

  /* In Fedora we use system-wide Crypto Policy */
  /* https://fedoraproject.org/wiki/Changes/CryptoPolicy */
  include "/etc/crypto-policies/back-ends/bind.config";
};

logging 
{
  channel default_debug {
    file "data/named.debug";
    severity dynamic;
  };

  channel default_stderr {
    file "data/named.stderr";
    severity debug;
  };

  channel query.log {
    file "data/named.query";
    severity debug;
  };

  category default { default_stderr; };
  category queries { query.log; };
};

acl portal { {{ proxy.internal.network }}/{{ proxy.internal.prefix }}; localhost; };

view "portal"
{
  match-clients { portal; localhost; };
  recursion yes;

  zone "." IN {
    type hint;
    file "/var/named/named.ca";
  };
  include "/etc/named.rfc1912.zones";

  # zone
  zone "portal.{{domain}}" { 
    {% if proxy_index == 0 %}
    type master;
    file "dynamic/portal.{{domain}}.zone.signed";
    update-policy {
      grant ddns-key.portal.{{ domain }} zonesub ANY;
    };
    {% else %}
    type slave;
    masters { {{ proxy.0.internal.ip.addr }}; };
    {% endif %}
  };

  # reverse zone
  zone "{{ (proxy.internal.network | ipaddr('revdns'))[2:-1] }}" {
    {% if proxy_index == 0 %}
    type master;
    file "dynamic/{{ (proxy.internal.network | ipaddr('revdns'))[2:-1] }}.zone.signed";
    update-policy {
      grant ddns-key.portal.{{ domain }} zonesub ANY;
    };
    {% else %}
    type slave;
    masters { {{ proxy.0.internal.ip.addr }}; };
    {% endif %}
  };

  zone "{{ (k8s.external_service_ip | ipaddr('revdns'))[2:-1] }}" {
    {% if proxy_index == 0 %}
    type master;
    file "dynamic/{{ (k8s.external_service_ip | ipaddr('revdns'))[2:-1] }}.zone.signed";
    update-policy {
      grant ddns-key.portal.{{ domain }} zonesub ANY;
    };
    {% else %}
    type slave;
    masters { {{ proxy.0.internal.ip.addr }}; };
    {% endif %}
  };

  zone "{{ domain }}" { 
    {% if proxy_index == 0 %}
    type master;
    file "dynamic/{{ domain }}.zone.signed";
    update-policy {
      grant ddns-key.portal.{{ domain }} zonesub ANY;
    };
    {% else %}
    type slave;
    masters { {{ proxy.0.internal.ip.addr }}; };
    {% endif %}
  };

  zone "{{ (proxy.external.network | ipaddr('revdns'))[2:-1] }}" {
    {% if proxy_index == 0 %}
    type master;
    file "dynamic/{{ (proxy.external.network | ipaddr('revdns'))[2:-1] }}.zone.signed";
    update-policy {
      grant ddns-key.portal.{{ domain }} zonesub ANY;
    };
    {% else %}
    type slave;
    masters { {{ proxy.0.internal.ip.addr }}; };
    {% endif %}
  };

};

view "external"
{
  match-clients           { any; };

  zone "{{ domain }}" { 
    in-view "portal";
  };

  zone "{{ (proxy.external.network | ipaddr('revdns'))[2:-1] }}" {
    in-view "portal";
  };

  zone "." IN {
    type hint;
    file "/var/named/named.ca";
  };

  recursion no;


};

